/***************************************************************************************************************************
***********************************************  THE OMEGA NETWORK PROJECT   ***********************************************
**************************************** Professor : Paulo Sérgio Lopes Souza       ****************************************
**************************************** Alunos    : Henrique Pizzol Grando         ****************************************
****************************************             Igor Quintal Mendes            ****************************************
****************************************             João Victor Almeida de Aguiar  ****************************************
****************************************             Moisés Botarro Ferraz Silva    ****************************************
***************************************************************************************************************************/


package languagemenu;

import java.net.URL;
import java.util.ResourceBundle;
import javafx.animation.FadeTransition;
import javafx.animation.TranslateTransition;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.MenuItem;
import javafx.scene.control.SplitMenuButton;
import javafx.scene.image.ImageView;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javafx.util.Duration;

/**
 *
 * @author igor
 */
public class MenuLanguageController implements Initializable {
    
    @FXML
    private Group groupIntro;
    @FXML
    private Group langMenu;
    @FXML
    private Group groupFinal;
    @FXML
    private SplitMenuButton btnSelect;
    
    private static int lang=0;
    @FXML
    private Text errorMsg;
    @FXML
    private MenuItem port;
    @FXML
    private MenuItem eng;
    @FXML
    private MenuItem french;
    @FXML
    private Button btn;
    @FXML
    private ImageView flagBrazil;
    @FXML
    private Text text01;
    @FXML
    private Text text02;
    @FXML
    private Text text03;
    
    private int click=0;
    
    @FXML
    private void portugueseProgram(ActionEvent event)  {

        
        lang=0;
        btnSelect.setText("Portuguese");
        click++;
        errorMsg.setVisible(false);
    }
    
    @FXML
    private void englishProgram(ActionEvent event)  {

        
        lang=1;
        btnSelect.setText("English");
        click++;
        errorMsg.setVisible(false);
    }
    
    @FXML
    private void frenchProgram(ActionEvent event)  {

        
        lang=2;
        btnSelect.setText("French");
        click++;
        errorMsg.setVisible(false);
    } 
       
    @FXML
    private void startProgram(ActionEvent event) throws Exception  {
        
        if (click>0) {
            
            FadeTransition outAnimation = new FadeTransition(Duration.millis(700), groupFinal);
            outAnimation.setFromValue(1.0);
            outAnimation.setToValue(0.0);
            outAnimation.setCycleCount(1);
            outAnimation.play();

            //PORTUGUES
            if(lang==0) {

            outAnimation.play();

            Parent root = FXMLLoader.load(getClass().getResource("/mainmenu/FXMLMainMenuPortuguese.fxml"));

            Scene scene = new Scene(root);

            Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();


            outAnimation.setOnFinished(new EventHandler<ActionEvent>(){

                    @Override
                    public void handle(ActionEvent arg0) {
                        stage.setScene(scene);
                        stage.show();
                    }
                });

            }

            //INGLES
            if(lang==1) {

            outAnimation.play();

            Parent root = FXMLLoader.load(getClass().getResource("/mainmenu/FXMLMainMenuEnglish.fxml"));

            Scene scene = new Scene(root);

            Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();


            outAnimation.setOnFinished(new EventHandler<ActionEvent>(){

                    @Override
                    public void handle(ActionEvent arg0) {
                        stage.setScene(scene);
                        stage.show();
                    }
                });

            }

            //FRANCES
            if(lang==2) {

            outAnimation.play();

            Parent root = FXMLLoader.load(getClass().getResource("/mainmenu/FXMLMainMenuFrench.fxml"));

            Scene scene = new Scene(root);

            Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();


            outAnimation.setOnFinished(new EventHandler<ActionEvent>(){

                    @Override
                    public void handle(ActionEvent arg0) {
                        stage.setScene(scene);
                        stage.show();
                    }
                });

            }
        }
        else {
            
            errorMsg.setVisible(true);
        }
        
        
    }
           
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        
           FadeTransition introAnimation0 = new FadeTransition(Duration.millis(3000), groupIntro);
           introAnimation0.setFromValue(0.0);
           introAnimation0.setToValue(1.0);
           introAnimation0.setCycleCount(1);
           introAnimation0.play();
           
           TranslateTransition introAnimation1 = new TranslateTransition(Duration.millis(2000), groupIntro);
           introAnimation1.setToY(68);
           introAnimation1.play();
           
           FadeTransition introAnimation2 = new FadeTransition(Duration.millis(3000), langMenu);
           introAnimation2.setFromValue(0.0);
           introAnimation2.setToValue(1.0);
           introAnimation2.setCycleCount(1);
           introAnimation2.play();
                   
           

    }    
    
}
