/***************************************************************************************************************************
***********************************************  THE OMEGA NETWORK PROJECT   ***********************************************
**************************************** Professor : Paulo Sérgio Lopes Souza       ****************************************
**************************************** Alunos    : Henrique Pizzol Grando         ****************************************
****************************************             Igor Quintal Mendes            ****************************************
****************************************             João Victor Almeida de Aguiar  ****************************************
****************************************             Moisés Botarro Ferraz Silva    ****************************************
***************************************************************************************************************************/

package about;

import java.net.URL;
import java.util.ResourceBundle;
import javafx.animation.FadeTransition;
import javafx.animation.ParallelTransition;
import javafx.animation.ScaleTransition;
import javafx.animation.SequentialTransition;
import javafx.animation.TranslateTransition;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.image.ImageView;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javafx.util.Duration;

/**
 * FXML Controller class
 *
 * @author igor
 */
public class AboutControllerFrench implements Initializable {
    @FXML
    private Group groupIntro;
    @FXML
    private ImageView icmcLogo;
    @FXML
    private Text text01;
    @FXML
    private Button btnDevelopers;
    @FXML
    private Button btnMenu;
    @FXML
    private Group groupLogo;

    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) {
       
        ScaleTransition animation01 = new ScaleTransition(Duration.millis(2000), groupIntro);
        animation01.setByX(-0.55f);
        animation01.setByY(-0.55f);
        animation01.setCycleCount(1);

        TranslateTransition animation02 = new TranslateTransition(Duration.millis(2000), groupIntro);
        animation02.setToY(animation02.getNode().getLayoutY() - 150);

        FadeTransition animation03 = new FadeTransition(Duration.millis(1500), groupLogo);
        animation03.setFromValue(0.0);
        animation03.setToValue(1.0);
        animation03.setCycleCount(1);

        FadeTransition animation04 = new FadeTransition(Duration.millis(1500), text01);
        animation04.setFromValue(0.0);
        animation04.setToValue(1.0);
        animation04.setCycleCount(1);

        ParallelTransition omegaAnimation01 = new ParallelTransition(animation01, animation02);
        ParallelTransition omegaAnimation02 = new ParallelTransition(animation03, animation04);

        SequentialTransition sequentialAnimation = new SequentialTransition(omegaAnimation01, omegaAnimation02) ;

        sequentialAnimation.play();
    }    

    @FXML
    private void openDevelopers(ActionEvent event) throws Exception {
        
        Parent root = FXMLLoader.load( getClass().getResource("/developers/DevelopersFrench.fxml") );
        
        Scene scene = new Scene (root);
        
        Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();
        
        stage.setScene (scene);
        stage.show();
    }

    @FXML
    private void returnMenu(ActionEvent event) throws Exception {
        
        Parent root = FXMLLoader.load( getClass().getResource("/mainmenu/FXMLMainMenuFrench.fxml") );
        
        Scene scene = new Scene (root);
        
        Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();
        
        stage.setScene (scene);
        stage.show();
    }
    
}
