/***************************************************************************************************************************
***********************************************  THE OMEGA NETWORK PROJECT   ***********************************************
**************************************** Professor : Paulo Sérgio Lopes Souza       ****************************************
**************************************** Alunos    : Henrique Pizzol Grando         ****************************************
****************************************             Igor Quintal Mendes            ****************************************
****************************************             João Victor Almeida de Aguiar  ****************************************
****************************************             Moisés Botarro Ferraz Silva    ****************************************
***************************************************************************************************************************/

package constructionsimulation;

import java.net.URL;
import java.util.ArrayList;
import java.util.ResourceBundle;
import javafx.animation.FadeTransition;
import javafx.animation.ParallelTransition;
import javafx.animation.SequentialTransition;
import javafx.animation.Transition;
import javafx.animation.TranslateTransition;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.Pane;
import javafx.scene.shape.Line;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javafx.util.Duration;

/**
 *
 * @author igor
 */
public class ConstructionEnglishController implements Initializable {
    
    @FXML private Text p0d0;
    @FXML private Text p0d1;
    @FXML private Text p0d2;
    @FXML private Text p1d0;
    @FXML private Text p1d1;
    @FXML private Text p1d2;
    @FXML private Text p2d0;
    @FXML private Text p2d1;
    @FXML private Text p2d2;
    @FXML private Text p3d0;
    @FXML private Text p3d1;
    @FXML private Text p3d2;
    @FXML private Text p4d0;
    @FXML private Text p4d1;
    @FXML private Text p4d2;
    @FXML private Text p5d0;
    @FXML private Text p5d1;
    @FXML private Text p5d2;
    @FXML private Text p6d0;
    @FXML private Text p6d1;
    @FXML private Text p6d2;
    @FXML private Text p7d0;
    @FXML private Text p7d1;
    @FXML private Text p7d2; 
    
    @FXML private Line _p0_1A;
    @FXML private Line _p1_1B;
    @FXML private Line _p2_1C;
    @FXML private Line _p3_1D;
    @FXML private Line _p4_1A;
    @FXML private Line _p5_1B;
    @FXML private Line _p6_1C;
    @FXML private Line _p7_1D;
    @FXML private Line _1A_2A;
    @FXML private Line _1B_2D;
    @FXML private Line _1C_2B;
    @FXML private Line _1D_2D;
    @FXML private Line _1A_2B;
    @FXML private Line _1B_2C;
    @FXML private Line _1C_2A;
    @FXML private Line _1D_2C;
    @FXML private Line _2A_3B;
    @FXML private Line _2D_3C;
    @FXML private Line _2B_3D;
    @FXML private Line _2D_3D;
    @FXML private Line _2B_3C;
    @FXML private Line _2C_3A;
    @FXML private Line _2A_3A;
    @FXML private Line _2C_3B; 
    @FXML private Line _3B_m2;
    @FXML private Line _3C_m4;
    @FXML private Line _3D_m6;
    @FXML private Line _3D_m7;
    @FXML private Line _3C_m5;
    @FXML private Line _3A_m0;
    @FXML private Line _3A_m1;
    @FXML private Line _3B_m3; 
    
    @FXML private Text zero;
    @FXML private Text one;
    @FXML private Text two;
    @FXML private Text three;
    @FXML private Text four;
    @FXML private Text five;
    @FXML private Text six;
    @FXML private Text seven;
    
    @FXML private Button btnPause;
    
    @FXML private Group groupNames;
       
    private static int xPosDigitZero = 270;
    private static int xPosDigitOne = 295;
    private static int xPosDigitTwo = 321;
    private static int yPosDigits = 566;
    private static int yUpDigit = 542;
    
    private static int i;
    private static int j;
    private static int flag = 0;
    private static int controller;
    private static int firstClick;
    private static int controll = 0;
    private static int paused = 0;
      
    private ArrayList<Text> digits;
    private ArrayList<Text> results;
    private ArrayList<Transition> transitionLeftRotate;
    private ArrayList<Integer> blockNumbers;
    private ArrayList<Line> lines;
    private ArrayList<Transition> stepByStep;
    private ArrayList<Transition> restOfTransition;
    
    private SequentialTransition animationFinal;
    @FXML
    private Pane BackgroundPanel;
    @FXML
    private Rectangle box1A;
    @FXML
    private Rectangle box1B;
    @FXML
    private Rectangle box1D;
    @FXML
    private Rectangle box1C;
    @FXML
    private Rectangle box2A;
    @FXML
    private Rectangle box2B;
    @FXML
    private Rectangle box2C;
    @FXML
    private Rectangle box2D;
    @FXML
    private Rectangle box3A;
    @FXML
    private Rectangle box3B;
    @FXML
    private Rectangle box3C;
    @FXML
    private Rectangle box3D;
    @FXML
    private Rectangle p0;
    @FXML
    private Rectangle p1;
    @FXML
    private Rectangle p2;
    @FXML
    private Rectangle p3;
    @FXML
    private Rectangle p4;
    @FXML
    private Rectangle p5;
    @FXML
    private Rectangle p6;
    @FXML
    private Rectangle p7;
    @FXML
    private Rectangle m0;
    @FXML
    private Text m0d0;
    @FXML
    private Text m0d1;
    @FXML
    private Text m0d2;
    @FXML
    private Rectangle m1;
    @FXML
    private Text m1d0;
    @FXML
    private Text m1d1;
    @FXML
    private Text m1d2;
    @FXML
    private Rectangle m2;
    @FXML
    private Text m2d0;
    @FXML
    private Text m2d1;
    @FXML
    private Text m2d2;
    @FXML
    private Rectangle m3;
    @FXML
    private Text m3d0;
    @FXML
    private Text m3d1;
    @FXML
    private Text m3d2;
    @FXML
    private Rectangle m4;
    @FXML
    private Text m4d0;
    @FXML
    private Text m4d1;
    @FXML
    private Text m4d2;
    @FXML
    private Rectangle m5;
    @FXML
    private Text m5d0;
    @FXML
    private Text m5d1;
    @FXML
    private Text m5d2;
    @FXML
    private Rectangle m6;
    @FXML
    private Text m6d0;
    @FXML
    private Text m6d1;
    @FXML
    private Text m6d2;
    @FXML
    private Rectangle m7;
    @FXML
    private Text m7d0;
    @FXML
    private Text m7d1;
    @FXML
    private Text m7d2;
    @FXML
    private Text text1A;
    @FXML
    private Text text1B;
    @FXML
    private Text text1C;
    @FXML
    private Text text1D;
    @FXML
    private Text text2A;
    @FXML
    private Text text2B;
    @FXML
    private Text text2C;
    @FXML
    private Text text2D;
    @FXML
    private Text text3A;
    @FXML
    private Text text3B;
    @FXML
    private Text text3C;
    @FXML
    private Text text3D;
    @FXML
    private Button btnFullAnimation;
    @FXML
    private Button btnNext;
    @FXML
    private Button btnStop;
    @FXML
    private Button btnMenu;
    
   
    private void loadArray(){
        
        digits = new ArrayList<Text>();
        results = new ArrayList<Text>();
        transitionLeftRotate = new ArrayList<Transition>();
        lines = new ArrayList<Line>();
        stepByStep = new ArrayList<Transition>();
        restOfTransition = new ArrayList<Transition>();
        animationFinal = new SequentialTransition();
        
        digits.add(p0d0);
        digits.add(p0d1);
        digits.add(p0d2);
        digits.add(p1d0);
        digits.add(p1d1);
        digits.add(p1d2);
        digits.add(p2d0);
        digits.add(p2d1);
        digits.add(p2d2);
        digits.add(p3d0);
        digits.add(p3d1);
        digits.add(p3d2);
        digits.add(p4d0);
        digits.add(p4d1);
        digits.add(p4d2);
        digits.add(p5d0);
        digits.add(p5d1);
        digits.add(p5d2);
        digits.add(p6d0);
        digits.add(p6d1);
        digits.add(p6d2);
        digits.add(p7d0);
        digits.add(p7d1);
        digits.add(p7d2);
        
        lines.add(_p0_1A);
        lines.add(_1A_2A);
        lines.add(_2A_3A);
        
        lines.add(_p1_1B);
        lines.add(_1B_2C);
        lines.add(_2C_3A);
        
        lines.add(_p2_1C);
        lines.add(_1C_2A);
        lines.add(_2A_3B);
        
        lines.add(_p3_1D);
        lines.add(_1D_2C);
        lines.add(_2C_3B);
        
        lines.add(_p4_1A);
        lines.add(_1A_2B);
        lines.add(_2B_3C);
        
        lines.add(_p5_1B);
        lines.add(_1B_2D);
        lines.add(_2D_3C);
        
        lines.add(_p6_1C);
        lines.add(_1C_2B);
        lines.add(_2B_3D);
        
        lines.add(_p7_1D);
        lines.add(_1D_2D);
        lines.add(_2D_3D);
        
        lines.add(_3A_m0);
        lines.add(_3A_m1);        
        lines.add(_3B_m2);
        lines.add(_3B_m3); 
        lines.add(_3C_m4);
        lines.add(_3C_m5); 
        lines.add(_3D_m6);
        lines.add(_3D_m7);
                         
        
        results.add(zero);
        results.add(zero);
        results.add(zero);
        
        results.add(two);
        results.add(four);
        results.add(one);
        
        results.add(four);
        results.add(one);
        results.add(two);
        
        results.add(six);
        results.add(five);
        results.add(three);
        
        results.add(one);
        results.add(two);
        results.add(four);
        
        results.add(three);
        results.add(six);
        results.add(five);
        
        results.add(five);
        results.add(three);
        results.add(six);
        
        results.add(seven);
        results.add(seven);
        results.add(seven);
               
    }
    
    
    private void createTransitions() {
                             //ALTERAR INDICES
        for(int i=0; i<8; i++) {
        
            //TRANSIÇÕES PARA LEVAR OS NÚMEROS AO DESTINO
            TranslateTransition moveZeroForward = new TranslateTransition(Duration.millis(1500), digits.get(i*3));
            TranslateTransition moveOneForward = new TranslateTransition(Duration.millis(1500), digits.get(i*3+1));
            TranslateTransition moveTwoForward = new TranslateTransition(Duration.millis(1500), digits.get(i*3+2));

            //DEFININDO PARÂMETROS DAS TRANSIÇÕES
            moveZeroForward.setToX(xPosDigitZero - moveZeroForward.getNode().getLayoutX());
            moveOneForward.setToX(xPosDigitOne - moveOneForward.getNode().getLayoutX());
            moveTwoForward.setToX(xPosDigitTwo - moveTwoForward.getNode().getLayoutX());
            moveZeroForward.setToY(yPosDigits - moveZeroForward.getNode().getLayoutY());
            moveOneForward.setToY(yPosDigits - moveOneForward.getNode().getLayoutY());
            moveTwoForward.setToY(yPosDigits - moveTwoForward.getNode().getLayoutY());
            
            //AGRUPA TODOS OS NÚMEROS EM UMA ÚNICA TRANSIÇÃO PARALELA PARA MOVE-LOS
            ParallelTransition moveNumbersForward = new ParallelTransition(moveZeroForward, moveOneForward, moveTwoForward);
           
            //TRANSIÇÕES PARA OS NÚMEROS DA PRIMEIRA ROTAÇÃO
            TranslateTransition moveZeroUpStep1 = new TranslateTransition(Duration.millis(300), digits.get(i*3));
            TranslateTransition moveZeroRightStep1 = new TranslateTransition(Duration.millis(300), digits.get(i*3));
            TranslateTransition moveZeroDownStep1 = new TranslateTransition(Duration.millis(300), digits.get(i*3));
            TranslateTransition moveOneLeftStep1 = new TranslateTransition(Duration.millis(300), digits.get(i*3+1));
            TranslateTransition moveTwoLeftStep1 = new TranslateTransition(Duration.millis(300), digits.get(i*3+2));

            //TRANSIÇÕES PARA OS NÚMEROS DA SEGUNDA ROTAÇÃO         
            TranslateTransition moveZeroUpStep2 = new TranslateTransition(Duration.millis(300), digits.get(i*3+1));
            TranslateTransition moveZeroRightStep2 = new TranslateTransition(Duration.millis(300), digits.get(i*3+1));
            TranslateTransition moveZeroDownStep2 = new TranslateTransition(Duration.millis(300), digits.get(i*3+1));
            TranslateTransition moveOneLeftStep2 = new TranslateTransition(Duration.millis(300), digits.get(i*3+2));
            TranslateTransition moveTwoLeftStep2 = new TranslateTransition(Duration.millis(300), digits.get(i*3));

            //TRANSIÇÕES PARA OS NÚMEROS DA TERCEIRA ROTAÇÃO  
            TranslateTransition moveZeroUpStep3 = new TranslateTransition(Duration.millis(300), digits.get(i*3+2));
            TranslateTransition moveZeroRightStep3 = new TranslateTransition(Duration.millis(300), digits.get(i*3+2));
            TranslateTransition moveZeroDownStep3 = new TranslateTransition(Duration.millis(300), digits.get(i*3+2));
            TranslateTransition moveOneLeftStep3 = new TranslateTransition(Duration.millis(300), digits.get(i*3));
            TranslateTransition moveTwoLeftStep3 = new TranslateTransition(Duration.millis(300), digits.get(i*3+1));

            //DEFINE AS POSIÇÕES PARA A PRIMEIRA ROTAÇÃO
            moveZeroUpStep1.setToY(yUpDigit - moveZeroUpStep1.getNode().getLayoutY());
            moveZeroRightStep1.setToX(xPosDigitTwo - moveZeroRightStep1.getNode().getLayoutX());
            moveZeroDownStep1.setToY(yPosDigits - moveZeroDownStep1.getNode().getLayoutY());
            moveOneLeftStep1.setToX(xPosDigitZero - moveOneLeftStep1.getNode().getLayoutX());
            moveTwoLeftStep1.setToX(xPosDigitOne - moveTwoLeftStep1.getNode().getLayoutX());

            //DEFINE AS POSIÇÕES PARA A SEGUNDA ROTAÇÃO
            moveZeroUpStep2.setToY( yUpDigit - moveZeroUpStep2.getNode().getLayoutY());
            moveZeroRightStep2.setToX(xPosDigitTwo - moveZeroRightStep2.getNode().getLayoutX());
            moveZeroDownStep2.setToY(yPosDigits - moveZeroDownStep2.getNode().getLayoutY());
            moveOneLeftStep2.setToX(xPosDigitZero - moveOneLeftStep2.getNode().getLayoutX());
            moveTwoLeftStep2.setToX(xPosDigitOne - moveTwoLeftStep2.getNode().getLayoutX());

            //DEFINE AS POSIÇÕES PARA A TERCEIRA ROTAÇÃO
            moveZeroUpStep3.setToY( yUpDigit - moveZeroUpStep3.getNode().getLayoutY());
            moveZeroRightStep3.setToX(xPosDigitTwo - moveZeroRightStep3.getNode().getLayoutX());
            moveZeroDownStep3.setToY(yPosDigits - moveZeroDownStep3.getNode().getLayoutY());
            moveOneLeftStep3.setToX(xPosDigitZero - moveOneLeftStep3.getNode().getLayoutX());
            moveTwoLeftStep3.setToX(xPosDigitOne - moveTwoLeftStep3.getNode().getLayoutX());

            //IMPRIME RESULTADO DA PRIMEIRA ROTAÇÃO
            FadeTransition resultFirstRotate = new FadeTransition(Duration.millis(700), results.get(i*3));
            resultFirstRotate.setFromValue(0.0);
            resultFirstRotate.setToValue(1.0);
            resultFirstRotate.setCycleCount(2);
            resultFirstRotate.setAutoReverse(true);
            
            //IMPRIME LINHA DA PRIMEIRA ROTAÇÃO
            FadeTransition lineFirstRotate = new FadeTransition(Duration.millis(700), lines.get(i*3));
            lineFirstRotate.setFromValue(0.0);
            lineFirstRotate.setToValue(1.0);
            lineFirstRotate.setCycleCount(1);
            
            //IMPRIME RESULTADO DA SEGUNDA ROTAÇÃO
            FadeTransition resultSecondRotate = new FadeTransition(Duration.millis(700), results.get(i*3+1));
            resultSecondRotate.setFromValue(0.0);
            resultSecondRotate.setToValue(1.0);
            resultSecondRotate.setCycleCount(2);
            resultSecondRotate.setAutoReverse(true);

            //IMPRIME LINHA DA SEGUNDA ROTAÇÃO
            FadeTransition lineSecondRotate = new FadeTransition(Duration.millis(700), lines.get(i*3+1));
            lineSecondRotate.setFromValue(0.0);
            lineSecondRotate.setToValue(1.0);
            lineSecondRotate.setCycleCount(1);
            
            //IMPRIME RESULTADO DA TERCEIRA ROTAÇÃO
            FadeTransition resultThirdRotate = new FadeTransition(Duration.millis(700), results.get(i*3+2));
            resultThirdRotate.setFromValue(0.0);
            resultThirdRotate.setToValue(1.0);
            resultThirdRotate.setCycleCount(2);
            resultThirdRotate.setAutoReverse(true);

            //IMPRIME LINHA DA TERCEIRA ROTAÇÃO
            FadeTransition lineThirdRotate = new FadeTransition(Duration.millis(700), lines.get(i*3+2));
            lineThirdRotate.setFromValue(0.0);
            lineThirdRotate.setToValue(1.0);
            lineThirdRotate.setCycleCount(1);
            
            //IMPRIME LINHA FINAL DE CONEXÃO À MEMÓRIA
            FadeTransition lineToMemory = new FadeTransition(Duration.millis(700), lines.get(24+i));
            lineToMemory.setFromValue(0.0);
            lineToMemory.setToValue(1.0);
            lineToMemory.setCycleCount(1);
            
            
            //DEIXA SEQUENCIAL AS MUDANÇAS DO PRIMEIRO DIGITO (PRIMEIRA ROTAÇÃO)
            SequentialTransition movingDigitZeroStep1 = new SequentialTransition(moveZeroUpStep1, moveZeroRightStep1, moveZeroDownStep1);
            //DEIXA PARALELO AS TRANSIÇÕES PARA A ROTAÇÃO (PRIMEIRA ROTAÇÃO)
            ParallelTransition leftRotateStep1 = new ParallelTransition(movingDigitZeroStep1, moveOneLeftStep1, moveTwoLeftStep1);
            //DEIXA SEQUENCIAL AS TRANSIÇÕES PARA A ROTAÇÃO COMPLETA (PRIMEIRA ROTAÇÃO)
            SequentialTransition leftRotateCompleteStep1 = new SequentialTransition(leftRotateStep1, resultFirstRotate, lineFirstRotate);
           
            //DEIXA SEQUENCIAL AS MUDANÇAS DO PRIMEIRO DIGITO (SEGUNDA ROTAÇÃO)
            SequentialTransition movingDigitZeroStep2 = new SequentialTransition(moveZeroUpStep2, moveZeroRightStep2, moveZeroDownStep2);
            //DEIXA PARALELO AS TRANSIÇÕES PARA A ROTAÇÃO (SEGUNDA ROTAÇÃO)            
            ParallelTransition leftRotateStep2 = new ParallelTransition(movingDigitZeroStep2, moveOneLeftStep2, moveTwoLeftStep2);
            //DEIXA SEQUENCIAL AS TRANSIÇÕES PARA A ROTAÇÃO COMPLETA (SEGUNDA ROTAÇÃO)
            SequentialTransition leftRotateCompleteStep2 = new SequentialTransition(leftRotateStep2, resultSecondRotate, lineSecondRotate);
           
            //DEIXA SEQUENCIAL AS MUDANÇAS DO PRIMEIRO DIGITO (TERCEIRA ROTAÇÃO)
            SequentialTransition movingDigitZeroStep3 = new SequentialTransition(moveZeroUpStep3, moveZeroRightStep3, moveZeroDownStep3);
            //DEIXA PARALELO AS TRANSIÇÕES PARA A ROTAÇÃO (TERCEIRA ROTAÇÃO)
            ParallelTransition leftRotateStep3 = new ParallelTransition(movingDigitZeroStep3, moveOneLeftStep3, moveTwoLeftStep3);
            //DEIXA SEQUENCIAL AS TRANSIÇÕES PARA A ROTAÇÃO COMPLETA (TERCEIRA ROTAÇÃO)
            SequentialTransition leftRotateCompleteStep3 = new SequentialTransition(leftRotateStep3, resultThirdRotate, lineThirdRotate, lineToMemory);
            
            //TRANSIÇÃO PARA OS NÚMEROS RETORNAREM
            TranslateTransition moveZeroBack = new TranslateTransition(Duration.millis(1500), digits.get(i*3));
            TranslateTransition moveOneBack = new TranslateTransition(Duration.millis(1500), digits.get(i*3+1));
            TranslateTransition moveTwoBack = new TranslateTransition(Duration.millis(1500), digits.get(i*3+2));

            //DEFINE AS POSIÇÕES DE VOLTA
            moveZeroBack.setToX(0);
            moveOneBack.setToX(0);
            moveTwoBack.setToX(0);
            moveZeroBack.setToY(0);
            moveOneBack.setToY(0);
            moveTwoBack.setToY(0);

            //DEIXA PARALELO AS TRANSIÇÕES DE VOLTA DOS NÚMEROS
            ParallelTransition moveNumbersBack = new ParallelTransition(moveZeroBack, moveOneBack, moveTwoBack);

            //CRIA A SEQUÊNCIA COMPLETA DE TRANSIÇÕES
            SequentialTransition finalAnimation = new SequentialTransition(moveNumbersForward, leftRotateCompleteStep1, leftRotateCompleteStep2, leftRotateCompleteStep3, moveNumbersBack);     
        
            transitionLeftRotate.add(finalAnimation);
            
            //CRIANDO CÓPIA PARA STEP-BY-STEP
            ParallelTransition stepByStepMoveNumbersForward = new ParallelTransition(moveNumbersForward);
            ParallelTransition stepByStepLeftRotateCompleteStep1 = new ParallelTransition(leftRotateCompleteStep1);
            ParallelTransition stepByStepLeftRotateCompleteStep2 = new ParallelTransition(leftRotateCompleteStep2);
            ParallelTransition stepByStepLeftRotateCompleteStep3 = new ParallelTransition(leftRotateCompleteStep3);
            ParallelTransition stepByStepMoveNumbersBack = new ParallelTransition(moveNumbersBack);
            stepByStep.add(stepByStepMoveNumbersForward);
            stepByStep.add(stepByStepLeftRotateCompleteStep1);
            stepByStep.add(stepByStepLeftRotateCompleteStep2);
            stepByStep.add(stepByStepLeftRotateCompleteStep3);
            stepByStep.add(stepByStepMoveNumbersBack);
               
        }
                     
    }
    
    private SequentialTransition createRestOfTransitionStep(int stop) {
        
        SequentialTransition transitionAnimation = new SequentialTransition();
        
        int rest, floor, roof, gap, start;
        
        rest = stop%5;
        floor = stop/5;
        roof = 5*floor + 5;
        gap = roof - (floor + rest);
        start = 5*floor + gap;
        
        switch (gap) {
            case 1:
                transitionAnimation = new SequentialTransition(stepByStep.get(roof-1));
                break;
            case 2:
                transitionAnimation = new SequentialTransition(stepByStep.get(roof-2), stepByStep.get(roof-1));
                break;
            case 3:
                transitionAnimation = new SequentialTransition(stepByStep.get(roof-3), stepByStep.get(roof-2), stepByStep.get(roof-1));
                break;
            case 4:
                transitionAnimation = new SequentialTransition(stepByStep.get(roof-4), stepByStep.get(roof-3), stepByStep.get(roof-2), stepByStep.get(roof-1));
                break;       
        }
       
        return transitionAnimation;
         
    }
    
    private SequentialTransition createRestOfTransition(int rest) {
        
        SequentialTransition transitionAnimation = new SequentialTransition();
        System.out.println("ENTROU NO SWITCH");
        
        
        switch(rest) {
            case 0:
                transitionAnimation = new SequentialTransition(transitionLeftRotate.get(0), transitionLeftRotate.get(1), transitionLeftRotate.get(2), transitionLeftRotate.get(3), transitionLeftRotate.get(4), transitionLeftRotate.get(5), transitionLeftRotate.get(6), transitionLeftRotate.get(7));
                break;
            case 1:
                transitionAnimation = new SequentialTransition(transitionLeftRotate.get(1), transitionLeftRotate.get(2), transitionLeftRotate.get(3), transitionLeftRotate.get(4), transitionLeftRotate.get(5), transitionLeftRotate.get(6), transitionLeftRotate.get(7));
                break;
            case 2:
                transitionAnimation = new SequentialTransition(transitionLeftRotate.get(2), transitionLeftRotate.get(3), transitionLeftRotate.get(4), transitionLeftRotate.get(5), transitionLeftRotate.get(6), transitionLeftRotate.get(7));           
                break;
            case 3:
                transitionAnimation = new SequentialTransition(transitionLeftRotate.get(3), transitionLeftRotate.get(4), transitionLeftRotate.get(5), transitionLeftRotate.get(6), transitionLeftRotate.get(7));    
                break;
            case 4:
                transitionAnimation = new SequentialTransition(transitionLeftRotate.get(4), transitionLeftRotate.get(5), transitionLeftRotate.get(6), transitionLeftRotate.get(7));        
                break;
            case 5:
                transitionAnimation = new SequentialTransition(transitionLeftRotate.get(5), transitionLeftRotate.get(6), transitionLeftRotate.get(7));        
                break;
            case 6:
                transitionAnimation = new SequentialTransition(transitionLeftRotate.get(6), transitionLeftRotate.get(7));         
                break;
            case 7:
                transitionAnimation = new SequentialTransition(transitionLeftRotate.get(7));         
                break;
        }
               
        return transitionAnimation;
    }

    
    @FXML
    private void playFullAnimation(ActionEvent event) {
        
        System.out.println("You clicked me!");
               
        if (firstClick>0 && controll ==0) {
                                  
            controll = 1;
            
            if(i%5!=0) {
                
                animationFinal = new SequentialTransition(createRestOfTransitionStep(i%5));
                flag = 1;
            }
            
            j=(i/5);
                    
            if (flag == 0) {
                
                animationFinal = new SequentialTransition(createRestOfTransition(j));
                animationFinal.play();
            }
            
            else {
                j++;
                animationFinal = new SequentialTransition(animationFinal, createRestOfTransition(j));
                animationFinal.play();
                
            }
            
            animationFinal.setOnFinished(new EventHandler<ActionEvent>(){

                @Override
                public void handle(ActionEvent arg0) {
                    controll = 0;
                }
            });
        }
        
        else if (firstClick==0 && controll == 0) {
            
            controll = 1;
            
            animationFinal = new SequentialTransition(createRestOfTransition(0));
            animationFinal.play();
            
            animationFinal.setOnFinished(new EventHandler<ActionEvent>(){

                @Override
                public void handle(ActionEvent arg0) {
                    controll = 0;
                }
            });
        }       
    }
        
    
    
    @FXML
    private void playStepByStep(ActionEvent event) {
        System.out.println("You clicked me!");
        
        if (controll == 0) {
            
            controll = 1;
            firstClick++;
            stepByStep.get(i).play();
            stepByStep.get(i).setOnFinished(new EventHandler<ActionEvent>(){

                @Override
                public void handle(ActionEvent arg0) {
                    controll = 0;
                }
            });
            i++;
        }
        
    }
       
    @FXML
    private void pauseAnimation(ActionEvent event) {
        System.out.println("You clicked me!");
        
        if(paused==0) {
            
            paused = 1;
            animationFinal.pause();
            btnPause.setText("Continue");
        }
        else if(paused==1) {
            
            paused = 0;
            animationFinal.play();
            btnPause.setText("Pause");
        }        
    }
    
    @FXML
    public void stopAnimation(ActionEvent event) throws Exception {
        
        animationFinal.stop();
        i=0;
        j=0;
        flag = 0;
        controller=0;
        firstClick=0;
        controll = 0;
        paused = 0;
        
        Parent root = FXMLLoader.load(getClass().getResource("ConstructionEnglish.fxml"));
        
        Scene scene = new Scene(root);
        
        Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();
        
        stage.setScene(scene);
        stage.show();
   
    }
        
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        
        loadArray();
        createTransitions();
        FadeTransition fadeNames = new FadeTransition(Duration.millis(1000), groupNames);
        fadeNames.setFromValue(0.0);
        fadeNames.setToValue(1.0);
        fadeNames.setCycleCount(1);
        fadeNames.play();
    }    

    @FXML
    private void returnMenu(ActionEvent event) throws Exception {
        
        Parent root = FXMLLoader.load( getClass().getResource("/mainmenu/FXMLMainMenuEnglish.fxml") );
        
        Scene scene = new Scene (root);
        
        Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();
        
        stage.setScene (scene);
        stage.show();
    }
    
}
