/***************************************************************************************************************************
***********************************************  THE OMEGA NETWORK PROJECT   ***********************************************
**************************************** Professor : Paulo Sérgio Lopes Souza       ****************************************
**************************************** Alunos    : Henrique Pizzol Grando         ****************************************
****************************************             Igor Quintal Mendes            ****************************************
****************************************             João Victor Almeida de Aguiar  ****************************************
****************************************             Moisés Botarro Ferraz Silva    ****************************************
***************************************************************************************************************************/


package mainmenu;

import java.net.URL;
import java.util.ResourceBundle;
import javafx.animation.FadeTransition;
import javafx.animation.SequentialTransition;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.image.ImageView;
import javafx.stage.Stage;
import javafx.util.Duration;

/**
 * FXML Controller class
 *
 * @author igor
 */
public class MainMenuControllerFrench implements Initializable {
    @FXML
    private Group groupIntro;
    @FXML
    private Group groupOptions;
    @FXML
    private Button btnSwitch;
    @FXML
    private Button btnConstruction;
    @FXML
    private Button btnNetwork;
    @FXML
    private Button btnAbout;
    @FXML
    private Button btnLanguage;
    @FXML
    private ImageView franceFlag;

    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) {

        FadeTransition flagAnimation = new FadeTransition(Duration.millis(750), franceFlag);
        flagAnimation.setFromValue(0.0);
        flagAnimation.setToValue(1.0);
        flagAnimation.setCycleCount(2);
        flagAnimation.setAutoReverse(true);
        
        FadeTransition groupAnimation = new FadeTransition(Duration.millis(1500), groupOptions);
        groupAnimation.setFromValue(0.0);
        groupAnimation.setToValue(1.0);
        groupAnimation.setCycleCount(1);

        SequentialTransition introAnimation = new SequentialTransition (flagAnimation, groupAnimation);
        
        introAnimation.play();
    }    

    @FXML
    private void startSwitch(ActionEvent event) throws Exception {
        
        Parent root = FXMLLoader.load(getClass().getResource("/switchsimulation/SwitchFrench.fxml"));
        
        Scene scene = new Scene(root);
        
        Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();
        
        stage.setScene(scene);
        stage.show();
    }

    @FXML
    private void startConstruction(ActionEvent event) throws Exception {
        
        Parent root = FXMLLoader.load(getClass().getResource("/constructionsimulation/ConstructionFrench.fxml"));
        
        Scene scene = new Scene(root);
        
        Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();
        
        stage.setScene(scene);
        stage.show();
    }

    @FXML
    private void startNetwork(ActionEvent event) throws Exception {
        
        Parent root = FXMLLoader.load(getClass().getResource("/networksimulation/NetworkFrench.fxml"));
        
        Scene scene = new Scene(root);
        
        Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();
        
        stage.setScene(scene);
        stage.show();        
    }

    @FXML
    private void openAbout(ActionEvent event) throws Exception {
        
        Parent root = FXMLLoader.load(getClass().getResource("/about/AboutFrench.fxml"));
        
        Scene scene = new Scene(root);
        
        Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();
        
        stage.setScene(scene);
        stage.show();         
        
    }

    @FXML
    private void openLanguage(ActionEvent event) throws Exception {
        
        Parent root = FXMLLoader.load(getClass().getResource("/languagemenu/FXMLMenuLanguage.fxml"));
        
        Scene scene = new Scene(root);
        
        Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();
        
        stage.setScene(scene);
        stage.show(); 
    }
    
}