/***************************************************************************************************************************
***********************************************  THE OMEGA NETWORK PROJECT   ***********************************************
**************************************** Professor : Paulo Sérgio Lopes Souza       ****************************************
**************************************** Alunos    : Henrique Pizzol Grando         ****************************************
****************************************             Igor Quintal Mendes            ****************************************
****************************************             João Victor Almeida de Aguiar  ****************************************
****************************************             Moisés Botarro Ferraz Silva    ****************************************
***************************************************************************************************************************/


package switchsimulation;

import java.util.*;
import javafx.event.ActionEvent;
import javafx.fxml.*;
import javafx.scene.*;
import javafx.scene.text.*;
import javafx.scene.shape.*;
import javafx.scene.image.*;
import javafx.scene.control.*;
import javafx.animation.*;
import javafx.stage.Stage;
import javafx.util.Duration;

public class SwitchControllerEnglish implements Initializable {

    @FXML private Button nextButton;

    @FXML private Button prevButton;

    @FXML private Rectangle boxSwitch;
    @FXML private Text textSwitch;

    @FXML private Text portUp;
    @FXML private Text portDown;

    @FXML private Text portUp_m0_binLevel1;
    @FXML private Text portUp_m2_binLevel1;

    @FXML private Text portUp_p0_binLevel1;


    @FXML private Text portDown_m0_binLevel1;
    @FXML private Text portDown_m2_binLevel1;

    @FXML private Text portDown_p2_binLevel1;


    @FXML private Text portUp_m0_binLevel2;
    @FXML private Text portUp_m2_binLevel2;

    @FXML private Text portUp_p0_binLevel2;


    @FXML private Text portDown_m0_binLevel2;
    @FXML private Text portDown_m2_binLevel2;

    @FXML private Text portDown_p2_binLevel2;


    @FXML private Text portUp_m0_binLevel3;
    @FXML private Text portUp_m2_binLevel3;

    @FXML private Text portUp_p0_binLevel3;


    @FXML private Text portDown_m0_binLevel3;
    @FXML private Text portDown_m2_binLevel3;

    @FXML private Text portDown_p2_binLevel3;



    @FXML private Text portUp_from;
    @FXML private Text portUp_to;

    @FXML private Text portDown_from;
    @FXML private Text portDown_to;


    @FXML private Rectangle compareBitsBoxLevel1;
    @FXML private Text result0Level1;
    @FXML private Text result1Level1;

    @FXML private Rectangle compareBitsBoxLevel2;
    @FXML private Text result0Level2;
    @FXML private Text result1Level2;


    @FXML private Rectangle compareBitsBoxLevel3;
    @FXML private Text result0Level3;
    @FXML private Text result1Level3;


    @FXML private Line portUp_downPort;
    @FXML private Line portUp_upPort;

    @FXML private Line portDown_downPort;
    @FXML private Line portDown_upPort;

    @FXML private Text xorExplain0;
    @FXML private Text xorExplain1;
    @FXML private ImageView atentionImage;

    
    @FXML private Text xValueExplainLevel1;

    @FXML private Text xValueExplainLevel2;

    @FXML private Text xValueExplainLevel3;


    @FXML private Line lineToFoward;
    @FXML private Polyline arrowLineToFoward;
    
    @FXML private Text forwardText;
    @FXML private Text switchText;

    @FXML private Button button1A;
    @FXML private Button button1B;
    @FXML private Button button1C;
    @FXML private Button button1D;

    @FXML private Button button2A;
    @FXML private Button button2B;
    @FXML private Button button2C;
    @FXML private Button button2D;

    @FXML private Button button3A;
    @FXML private Button button3B;
    @FXML private Button button3C;
    @FXML private Button button3D;

    @FXML private Text textSelectSwitch;


    @FXML ToggleButton fastModeButton;
    private double velocity;



    ArrayList<Animation> animations;
    int actualAnimation;
    @FXML
    private Line _p7_1D;
    @FXML
    private Line _p7_1D1;
    @FXML
    private Line _p7_1D2;
    @FXML
    private Line _p7_1D21;
    @FXML
    private Button returnButton;

    

    private ArrayList<Animation> createAnimationsForSimulation(String switchString)
    {
        ArrayList<Animation> animations = new ArrayList<Animation> ();

        Rectangle compareBitsBox = null;
        Text result0 = null;
        Text result1 = null;

        Text xValueExplain = null;


        Text portUp_m0_bin  = null;
        Text portUp_m2_bin  = null;

        Text portUp_p0_bin  = null;

        Text portDown_p2_bin= null;


        Text portDown_m0_bin = null;
        Text portDown_m2_bin = null;

        if (Integer.parseInt(switchString.substring(0,1)) == 1)
        {
            compareBitsBox = compareBitsBoxLevel1;
            result0 = result0Level1;
            result1 = result1Level1;

            xValueExplain = xValueExplainLevel1;


            portUp_m0_bin  = portUp_m0_binLevel1;
            portUp_m2_bin  = portUp_m2_binLevel1;

            portUp_p0_bin  = portUp_p0_binLevel1;

            portDown_p2_bin= portDown_p2_binLevel1;


            portDown_m0_bin = portDown_m0_binLevel1;
            portDown_m2_bin = portDown_m2_binLevel1;
        }
        else if (Integer.parseInt(switchString.substring(0,1)) == 2)
        {
            compareBitsBox = compareBitsBoxLevel2;
            result0 = result0Level2;
            result1 = result1Level2;

            xValueExplain = xValueExplainLevel2;


            portUp_m0_bin  = portUp_m0_binLevel2;
            portUp_m2_bin  = portUp_m2_binLevel2;

            portUp_p0_bin  = portUp_p0_binLevel2;

            portDown_p2_bin= portDown_p2_binLevel2;


            portDown_m0_bin = portDown_m0_binLevel2;
            portDown_m2_bin = portDown_m2_binLevel2;
        }
        else if (Integer.parseInt(switchString.substring(0,1)) == 3)
        {
            compareBitsBox = compareBitsBoxLevel3;
            result0 = result0Level3;
            result1 = result1Level3;

            xValueExplain = xValueExplainLevel3;


            portUp_m0_bin  = portUp_m0_binLevel3;
            portUp_m2_bin  = portUp_m2_binLevel3;

            portUp_p0_bin  = portUp_p0_binLevel3;

            portDown_p2_bin= portDown_p2_binLevel3;


            portDown_m0_bin = portDown_m0_binLevel3;
            portDown_m2_bin = portDown_m2_binLevel3;
        }
        else
            return animations;


        if (switchString.substring(1,2).compareTo("A") == 0)
        {
            portUp.setText("0");
            portDown.setText("1");
        }
        else if (switchString.substring(1,2).compareTo("B") == 0)
        {
            portUp.setText("2");
            portDown.setText("3");
        }
        else if (switchString.substring(1,2).compareTo("C") == 0)
        {
            portUp.setText("4");
            portDown.setText("5");
        }
        else if (switchString.substring(1,2).compareTo("D") == 0)
        {
            portUp.setText("6");
            portDown.setText("7");
        }
        else
            return animations;
        

        textSwitch.setText(switchString);


        actualAnimation = 0;

        // For all the translate transitions createds!
        TranslateTransition translateTransition;

        ScaleTransition scaleTransition;

        FadeTransition fadeTransition;

        SequentialTransition sequentialTransition;
        
        ParallelTransition parallelTransition;


        TranslateTransition translateTransition1;
        TranslateTransition translateTransition2;
        TranslateTransition translateTransition3;
        TranslateTransition translateTransition4;


        FadeTransition fadeTransition1;
        FadeTransition fadeTransition2;
        FadeTransition fadeTransition3;


        SequentialTransition sequentialTransition1;
        SequentialTransition sequentialTransition2;


        ParallelTransition parallelTransition1;
        ParallelTransition parallelTransition2;
        ParallelTransition parallelTransition3;
        ParallelTransition parallelTransition4;
        ParallelTransition parallelTransition5;
        ParallelTransition parallelTransition6;
        ParallelTransition parallelTransition7;

        ArrayList<Transition> transitions;





        /*FIRST ANIMATION: values inside boxSwitch go out and becom decimals!*/
        // boxSwitch texts animation
        translateTransition = createTranslateTransition(2000, textSwitch, 0, 0, 0, 130);
        scaleTransition = createScaleTransition(2000, textSwitch, 1, 1, 0.5f, 0.5f);

        // Decimal Values vanish
        fadeTransition1 = createFadeTransition(1000, portUp, 1, 0);
        fadeTransition2 = createFadeTransition(1000, portDown, 1, 0);
        parallelTransition1 = createParallelTransition(fadeTransition1, fadeTransition2);

        parallelTransition = createParallelTransition(translateTransition,
                                                        scaleTransition,
                                                        parallelTransition1);


        animations.add(parallelTransition);






        /*************************************************************************************************
        ********************************** FIRST EXAMPLE : 000 (PORT 2) ********************************** 
        *************************************************************************************************/





        /*SECOND ANIMATION: value 000 is shown and goes to port 2*/
        fadeTransition1     = createFadeTransition(500, portUp_m0_bin, 0, 1);
        translateTransition1= createTranslateTransition(1000, portUp_m0_bin, 0, 0, 130, 0);
        fadeTransition2     = createFadeTransition(500, portUp_p0_bin, 0, 1);
        translateTransition2= createTranslateTransition(1000, portUp_p0_bin, 0, 0, 130, 0);

        parallelTransition1 = createParallelTransition(fadeTransition1, translateTransition1,
                                                       fadeTransition2, translateTransition2);

        fadeTransition1     = createFadeTransition(500, portUp_to, 0, 1);
        fadeTransition2     = createFadeTransition(500, portUp_from, 0, 1);
        fadeTransition3     = createFadeTransition(500, xValueExplain, 0,1);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2, fadeTransition3);

        parallelTransition  = createParallelTransition(parallelTransition1, parallelTransition2);


        animations.add(parallelTransition);



        /*THIRD ANIMATION: values 000 and 010 are compared to discover the path*/
        translateTransition1= createTranslateTransition(1000, portUp_m0_bin, 130, 0, 265, -165);
        translateTransition2= createTranslateTransition(1000, portUp_p0_bin, 130, 0, 265, -165);
        parallelTransition1 = createParallelTransition(translateTransition1, translateTransition2);

        fadeTransition1     = createFadeTransition(500, portUp_to, 1, 0);
        fadeTransition2     = createFadeTransition(500, portUp_from, 1, 0);
        fadeTransition3     = createFadeTransition(500, xValueExplain, 1,0);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2, fadeTransition3);


        parallelTransition  = createParallelTransition(parallelTransition1, parallelTransition2);


        animations.add(parallelTransition);


        /*FORTH ANIMATION: comparates bits to discover the path*/
        
        scaleTransition     = createScaleTransition(900, lineToFoward, 0, 1, 1, 1);
        translateTransition = createTranslateTransition(900, lineToFoward, -40, 0, 0, 0);

        parallelTransition1 = createParallelTransition(scaleTransition, translateTransition);

        fadeTransition1     = createFadeTransition(100, arrowLineToFoward, 0, 1);
        fadeTransition2     = createFadeTransition(100, forwardText, 0, 1);

        parallelTransition2 = createParallelTransition(fadeTransition1,  fadeTransition2);

        sequentialTransition= createSequentialTransition(parallelTransition1, parallelTransition2);



        fadeTransition1     = createFadeTransition(1000, result0, 0, 1);
        fadeTransition2     = createFadeTransition(1000, compareBitsBox, 0, 1);


        parallelTransition1 = createParallelTransition(fadeTransition1, fadeTransition2);
        
        fadeTransition1     = createFadeTransition(1000, atentionImage, 0, 1);
        fadeTransition2     = createFadeTransition(1000, xorExplain0, 0, 1);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2);

        parallelTransition  = createParallelTransition(sequentialTransition,
                                                        parallelTransition1,
                                                        parallelTransition2);

        animations.add(parallelTransition);


        /*FIFTH ANIMATION: creates path to routing*/
        translateTransition = createTranslateTransition(1000, portUp_upPort, -100, 0, 0, 0);
        scaleTransition     = createScaleTransition(1000, portUp_upPort, 0, 0, 1, 1);

        parallelTransition  = createParallelTransition(translateTransition, scaleTransition);

        animations.add(parallelTransition);


        /*SIXTH ANIMATION: routing and finishing*/

        // Value being routed
        translateTransition1 = createTranslateTransition(1000, portUp_m0_bin, 265, -165, 120, 0);
        translateTransition3 = createTranslateTransition(1400, portUp_m0_bin, 120, 0, 400, 0);
        sequentialTransition1= createSequentialTransition(translateTransition1,
                                                            translateTransition3);

        translateTransition1 = createTranslateTransition(1000, portUp_p0_bin, 265, -165, 120, 0);
        translateTransition3 = createTranslateTransition(1400, portUp_p0_bin, 120, 0, 400, 0);
        sequentialTransition2= createSequentialTransition(translateTransition1,
                                                            translateTransition3);

        parallelTransition1 = createParallelTransition(sequentialTransition1,
                                                       sequentialTransition2);



        // Goodbye, value :'(
        translateTransition1 = createTranslateTransition(1500, portUp_m0_bin, 400, 0, 600, 0);
        fadeTransition1      = createFadeTransition(1500, portUp_m0_bin, 1, 0);

        translateTransition2 = createTranslateTransition(1500, portUp_p0_bin, 400, 0, 600, 0);
        fadeTransition2      = createFadeTransition(1500, portUp_p0_bin, 1, 0);

        parallelTransition2  = createParallelTransition(translateTransition1,
                                                        fadeTransition1,
                                                        translateTransition2,
                                                        fadeTransition2);


        // The routing line is gone!
        translateTransition  = createTranslateTransition(1000, portUp_upPort, 0, 0, 100, 0);
        scaleTransition      = createScaleTransition(1000, portUp_upPort, 1, 1, 0, 0);

        parallelTransition3  = createParallelTransition(translateTransition, scaleTransition);

        // Comparation values are gone!
        fadeTransition1      = createFadeTransition(1000, result0, 1, 0);
        fadeTransition2      = createFadeTransition(1000, compareBitsBox, 1, 0);

        parallelTransition4  = createParallelTransition(fadeTransition1, fadeTransition2);

        // Explain 
        fadeTransition1      = createFadeTransition(1000, atentionImage, 1, 0);
        fadeTransition2      = createFadeTransition(1000, xorExplain0, 1, 0);

        parallelTransition5  = createParallelTransition(fadeTransition1, fadeTransition2);


        // Arrow of explain is gone!
        scaleTransition     = createScaleTransition(900, lineToFoward, 1, 1, 0, 1);
        translateTransition = createTranslateTransition(900, lineToFoward, 0, 0, 40, 0);

        parallelTransition6 = createParallelTransition(scaleTransition, translateTransition);

        fadeTransition1     = createFadeTransition(100, arrowLineToFoward, 1, 0);
        fadeTransition2     = createFadeTransition(100, forwardText, 1, 0);

        parallelTransition7 = createParallelTransition(fadeTransition1,  fadeTransition2);

        sequentialTransition= createSequentialTransition(parallelTransition6, parallelTransition7);



        parallelTransition  = createParallelTransition(parallelTransition2,
                                                        parallelTransition3,
                                                        parallelTransition4,
                                                        parallelTransition5,
                                                        sequentialTransition);


        sequentialTransition= createSequentialTransition(parallelTransition1,
                                                          parallelTransition);

        animations.add(sequentialTransition);


        /*************************************************************************************************
        ********************************** SECOND EXAMPLE : 010 (PORT 2) ********************************* 
        *************************************************************************************************/

        /*SECOND ANIMATION: value 000 is shown and goes to port 2*/
        fadeTransition1     = createFadeTransition(500, portUp_m2_bin, 0, 1);
        translateTransition1= createTranslateTransition(1000, portUp_m2_bin, 0, 0, 130, 0);
        fadeTransition2     = createFadeTransition(500, portUp_p0_bin, 0, 1);
        translateTransition2= createTranslateTransition(1000, portUp_p0_bin, 0, 0, 130, 0);

        parallelTransition1 = createParallelTransition(fadeTransition1, translateTransition1,
                                                       fadeTransition2, translateTransition2);

        fadeTransition1     = createFadeTransition(500, portUp_to, 0, 1);
        fadeTransition2     = createFadeTransition(500, portUp_from, 0, 1);
        fadeTransition3     = createFadeTransition(500, xValueExplain, 0,1);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2, fadeTransition3);

        parallelTransition  = createParallelTransition(parallelTransition1, parallelTransition2);


        animations.add(parallelTransition);



        /*THIRD ANIMATION: values 000 and 010 are compared to discover the path*/
        translateTransition1 = createTranslateTransition(1000, portUp_m2_bin, 130, 0, 265, -165);
        translateTransition2 = createTranslateTransition(1000, portUp_p0_bin, 130, 0, 265, -165);
        parallelTransition1  = createParallelTransition(translateTransition1, translateTransition2);

        fadeTransition1     = createFadeTransition(500, portUp_to, 1, 0);
        fadeTransition2     = createFadeTransition(500, portUp_from, 1, 0);
        fadeTransition3     = createFadeTransition(500, xValueExplain, 1,0);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2, fadeTransition3);

        parallelTransition  = createParallelTransition(parallelTransition1, parallelTransition2);

        animations.add(parallelTransition);


        /*FORTH ANIMATION: comparates bits to discover the path*/
        scaleTransition     = createScaleTransition(900, lineToFoward, 0, 1, 1, 1);
        translateTransition = createTranslateTransition(900, lineToFoward, -40, 0, 0, 0);

        parallelTransition1 = createParallelTransition(scaleTransition, translateTransition);

        fadeTransition1     = createFadeTransition(100, arrowLineToFoward, 0, 1);
        fadeTransition2     = createFadeTransition(100, switchText, 0, 1);

        parallelTransition2 = createParallelTransition(fadeTransition1,  fadeTransition2);

        sequentialTransition= createSequentialTransition(parallelTransition1, parallelTransition2);



        fadeTransition1     = createFadeTransition(1000, result1, 0, 1);
        fadeTransition2     = createFadeTransition(1000, compareBitsBox, 0, 1);


        parallelTransition1 = createParallelTransition(fadeTransition1, fadeTransition2);
        
        fadeTransition1     = createFadeTransition(1000, atentionImage, 0, 1);
        fadeTransition2     = createFadeTransition(1000, xorExplain1, 0, 1);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2);

        parallelTransition  = createParallelTransition(sequentialTransition,
                                                        parallelTransition1,
                                                        parallelTransition2);

        animations.add(parallelTransition);


        /*FIFTH ANIMATION: creates path to routing*/
        translateTransition = createTranslateTransition(1000, portUp_downPort, -100, -80, 0, 0);
        scaleTransition     = createScaleTransition(1000, portUp_downPort, 0, 0, 1, 1);

        parallelTransition  = createParallelTransition(translateTransition, scaleTransition);

        animations.add(parallelTransition);


        /*SIXTH ANIMATION: routing and finishing*/

        // Value being routed
        translateTransition1 = createTranslateTransition(1000, portUp_m2_bin, 265, -165, 120, 0);
        translateTransition2 = createTranslateTransition(400, portUp_m2_bin, 120, 0, 190, 0);
        translateTransition3 = createTranslateTransition(1000, portUp_m2_bin, 190, 0, 400, 160);
        sequentialTransition1= createSequentialTransition(translateTransition1,
                                                            translateTransition2,
                                                            translateTransition3);

        translateTransition1 = createTranslateTransition(1000, portUp_p0_bin, 265, -165, 120, 0);
        translateTransition2 = createTranslateTransition(400, portUp_p0_bin, 120, 0, 140, 0);
        translateTransition3 = createTranslateTransition(1000, portUp_p0_bin, 140, 0, 340, 160);
        sequentialTransition2= createSequentialTransition(translateTransition1,
                                                            translateTransition2,
                                                            translateTransition3);

        parallelTransition1 = createParallelTransition(sequentialTransition1,
                                                       sequentialTransition2);



        // Goodbye, value :'(
        translateTransition1 = createTranslateTransition(1500, portUp_m2_bin, 400, 160, 600, 160);
        fadeTransition1      = createFadeTransition(1500, portUp_m2_bin, 1, 0);

        translateTransition2 = createTranslateTransition(1500, portUp_p0_bin, 340, 160, 600, 160);
        fadeTransition2      = createFadeTransition(1500, portUp_p0_bin, 1, 0);

        parallelTransition2  = createParallelTransition(translateTransition1,
                                                        fadeTransition1,
                                                        translateTransition2,
                                                        fadeTransition2);

        // The routing line is gone!
        translateTransition  = createTranslateTransition(1000, portUp_downPort, 0, 0, 100, 80);
        scaleTransition      = createScaleTransition(1000, portUp_downPort, 1, 1, 0, 0);
        parallelTransition3  = createParallelTransition(translateTransition, scaleTransition);

        // Comparation values are gone!
        fadeTransition1      = createFadeTransition(1000, result1, 1, 0);
        fadeTransition2      = createFadeTransition(1000, compareBitsBox, 1, 0);
        parallelTransition4  = createParallelTransition(fadeTransition1, fadeTransition2);


        // Explain 
        fadeTransition1      = createFadeTransition(1000, atentionImage, 1, 0);
        fadeTransition2      = createFadeTransition(1000, xorExplain1, 1, 0);

        parallelTransition5  = createParallelTransition(fadeTransition1, fadeTransition2);

        // Arrow of explain is gone!
        scaleTransition     = createScaleTransition(900, lineToFoward, 1, 1, 0, 1);
        translateTransition = createTranslateTransition(900, lineToFoward, 0, 0, 40, 0);

        parallelTransition6 = createParallelTransition(scaleTransition, translateTransition);

        fadeTransition1     = createFadeTransition(100, arrowLineToFoward, 1, 0);
        fadeTransition2     = createFadeTransition(100, switchText, 1, 0);

        parallelTransition7 = createParallelTransition(fadeTransition1,  fadeTransition2);

        sequentialTransition= createSequentialTransition(parallelTransition6, parallelTransition7);


        parallelTransition  = createParallelTransition(parallelTransition2,
                                                        parallelTransition3,
                                                        parallelTransition4,
                                                        parallelTransition5,
                                                        sequentialTransition);


        sequentialTransition= createSequentialTransition(parallelTransition1,
                                                          parallelTransition);

        animations.add(sequentialTransition);





        /*************************************************************************************************
        ********************************** THIRD EXAMPLE : 000 (PORT 3) ********************************** 
        *************************************************************************************************/



        /*SECOND ANIMATION: value 000 is shown and goes to port 2*/
        fadeTransition1     = createFadeTransition(500, portDown_m0_bin, 0, 1);
        translateTransition1= createTranslateTransition(1000, portDown_m0_bin, 0, 0, 130, 0);
        fadeTransition2     = createFadeTransition(500, portDown_p2_bin, 0, 1);
        translateTransition2= createTranslateTransition(1000, portDown_p2_bin, 0, 0, 130, 0);

        parallelTransition1 = createParallelTransition(fadeTransition1, translateTransition1,
                                                       fadeTransition2, translateTransition2);

        fadeTransition1     = createFadeTransition(500, portDown_to, 0, 1);
        fadeTransition2     = createFadeTransition(500, portDown_from, 0, 1);
        fadeTransition3     = createFadeTransition(500, xValueExplain, 0,1);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2, fadeTransition3);

        parallelTransition  = createParallelTransition(parallelTransition1, parallelTransition2);


        animations.add(parallelTransition);



        /*THIRD ANIMATION: values 000 and 010 are compared to discover the path*/
        translateTransition1 = createTranslateTransition(1000, portDown_m0_bin, 130, 0, 265, -325);
        translateTransition2 = createTranslateTransition(1000, portDown_p2_bin, 130, 0, 265, -325);
        parallelTransition1  = createParallelTransition(translateTransition1, translateTransition2);

        fadeTransition1     = createFadeTransition(500, portDown_to, 1, 0);
        fadeTransition2     = createFadeTransition(500, portDown_from, 1, 0);
        fadeTransition3     = createFadeTransition(500, xValueExplain, 1,0);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2, fadeTransition3);


        parallelTransition  = createParallelTransition(parallelTransition1, parallelTransition2);


        animations.add(parallelTransition);


        /*FORTH ANIMATION: comparates bits to discover the path*/
        scaleTransition     = createScaleTransition(900, lineToFoward, 0, 1, 1, 1);
        translateTransition = createTranslateTransition(900, lineToFoward, -40, 0, 0, 0);

        parallelTransition1 = createParallelTransition(scaleTransition, translateTransition);

        fadeTransition1     = createFadeTransition(100, arrowLineToFoward, 0, 1);
        fadeTransition2     = createFadeTransition(100, switchText, 0, 1);

        parallelTransition2 = createParallelTransition(fadeTransition1,  fadeTransition2);

        sequentialTransition= createSequentialTransition(parallelTransition1, parallelTransition2);



        fadeTransition1     = createFadeTransition(1000, result1, 0, 1);
        fadeTransition2     = createFadeTransition(1000, compareBitsBox, 0, 1);


        parallelTransition1 = createParallelTransition(fadeTransition1, fadeTransition2);
        
        fadeTransition1     = createFadeTransition(1000, atentionImage, 0, 1);
        fadeTransition2     = createFadeTransition(1000, xorExplain1, 0, 1);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2);

        parallelTransition  = createParallelTransition(sequentialTransition,
                                                        parallelTransition1,
                                                        parallelTransition2);

        animations.add(parallelTransition);


        /*FIFTH ANIMATION: creates path to routing*/
        translateTransition = createTranslateTransition(1000, portDown_upPort, -100, 80, 0, 0);
        scaleTransition     = createScaleTransition(1000, portDown_upPort, 0, 0, 1, 1);

        parallelTransition  = createParallelTransition(translateTransition, scaleTransition);

        animations.add(parallelTransition);


        /*SIXTH ANIMATION: routing and finishing*/

        // Value being routed
        translateTransition1 = createTranslateTransition(1000, portDown_m0_bin, 265, -325, 120, 0);
        translateTransition2 = createTranslateTransition(400, portDown_m0_bin, 120, 0, 140, 0);
        translateTransition3 = createTranslateTransition(1000, portDown_m0_bin, 140, 0, 340, -160);
        sequentialTransition1= createSequentialTransition(translateTransition1,
                                                            translateTransition2,
                                                            translateTransition3);

        translateTransition1 = createTranslateTransition(1000, portDown_p2_bin, 265, -325, 120, 0);
        translateTransition2 = createTranslateTransition(400, portDown_p2_bin, 120, 0, 190, 0);
        translateTransition3 = createTranslateTransition(1000, portDown_p2_bin, 190, 0, 400, -160);
        sequentialTransition2= createSequentialTransition(translateTransition1,
                                                            translateTransition2,
                                                            translateTransition3);

        parallelTransition1  = createParallelTransition(sequentialTransition1, sequentialTransition2);

        // Goodbye, value :'(
        translateTransition1 = createTranslateTransition(1500, portDown_m0_bin, 340, -160, 600, -160);
        fadeTransition1      = createFadeTransition(1500, portDown_m0_bin, 1, 0);

        translateTransition2 = createTranslateTransition(1500, portDown_p2_bin, 400, -160, 600, -160);
        fadeTransition2      = createFadeTransition(1500, portDown_p2_bin, 1, 0);

        parallelTransition2  = createParallelTransition(translateTransition1,
                                                        fadeTransition1,
                                                        translateTransition2,
                                                        fadeTransition2);


        // The routing line is gone!
        translateTransition  = createTranslateTransition(1000, portDown_upPort, 0, 0, 100, -80);
        scaleTransition      = createScaleTransition(1000, portDown_upPort, 1, 1, 0, 0);
        parallelTransition3  = createParallelTransition(translateTransition, scaleTransition);

        // Comparation values are gone!
        fadeTransition1      = createFadeTransition(1000, result1, 1, 0);
        fadeTransition2      = createFadeTransition(1000, compareBitsBox, 1, 0);
        parallelTransition4  = createParallelTransition(fadeTransition1, fadeTransition2);

        // Explain 
        fadeTransition1      = createFadeTransition(1000, atentionImage, 1, 0);
        fadeTransition2      = createFadeTransition(1000, xorExplain1, 1, 0);

        parallelTransition5  = createParallelTransition(fadeTransition1, fadeTransition2);

        // Arrow of explain is gone!
        scaleTransition     = createScaleTransition(900, lineToFoward, 1, 1, 0, 1);
        translateTransition = createTranslateTransition(900, lineToFoward, 0, 0, 40, 0);
        parallelTransition6 = createParallelTransition(scaleTransition, translateTransition);

        fadeTransition1     = createFadeTransition(100, arrowLineToFoward, 1, 0);
        fadeTransition2     = createFadeTransition(100, switchText, 1, 0);
        parallelTransition7 = createParallelTransition(fadeTransition1,  fadeTransition2);

        sequentialTransition= createSequentialTransition(parallelTransition6, parallelTransition7);


        parallelTransition  = createParallelTransition(parallelTransition2,
                                                        parallelTransition3,
                                                        parallelTransition4,
                                                        parallelTransition5,
                                                        sequentialTransition);


        sequentialTransition= createSequentialTransition(parallelTransition1,
                                                          parallelTransition);

        animations.add(sequentialTransition);




        /*************************************************************************************************
        ********************************** FORTH EXAMPLE : 010 (PORT 3) ********************************** 
        *************************************************************************************************/





        /*SECOND ANIMATION: value 000 is shown and goes to port 2*/
        fadeTransition1     = createFadeTransition(500, portDown_m2_bin, 0, 1);
        translateTransition1= createTranslateTransition(1000, portDown_m2_bin, 0, 0, 130, 0);
        fadeTransition2     = createFadeTransition(500, portDown_p2_bin, 0, 1);
        translateTransition2= createTranslateTransition(1000, portDown_p2_bin, 0, 0, 130, 0);

        parallelTransition1 = createParallelTransition(fadeTransition1, translateTransition1,
                                                       fadeTransition2, translateTransition2);

        fadeTransition1     = createFadeTransition(500, portDown_to, 0, 1);
        fadeTransition2     = createFadeTransition(500, portDown_from, 0, 1);
        fadeTransition3     = createFadeTransition(500, xValueExplain, 0,1);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2, fadeTransition3);

        parallelTransition  = createParallelTransition(parallelTransition1, parallelTransition2);


        animations.add(parallelTransition);



        /*THIRD ANIMATION: values 000 and 010 are compared to discover the path*/
        translateTransition1 = createTranslateTransition(1000, portDown_m2_bin, 130, 0, 265, -325);
        translateTransition2 = createTranslateTransition(1000, portDown_p2_bin, 130, 0, 265, -325);
        parallelTransition1  = createParallelTransition(translateTransition1, translateTransition2);

        fadeTransition1     = createFadeTransition(500, portDown_to, 1, 0);
        fadeTransition2     = createFadeTransition(500, portDown_from, 1, 0);
        fadeTransition3     = createFadeTransition(500, xValueExplain, 1,0);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2, fadeTransition3);

        parallelTransition  = createParallelTransition(parallelTransition1, parallelTransition2);


        animations.add(parallelTransition);


        /*FORTH ANIMATION: comparates bits to discover the path*/
        scaleTransition     = createScaleTransition(900, lineToFoward, 0, 1, 1, 1);
        translateTransition = createTranslateTransition(900, lineToFoward, -40, 0, 0, 0);

        parallelTransition1 = createParallelTransition(scaleTransition, translateTransition);

        fadeTransition1     = createFadeTransition(100, arrowLineToFoward, 0, 1);
        fadeTransition2     = createFadeTransition(100, forwardText, 0, 1);

        parallelTransition2 = createParallelTransition(fadeTransition1,  fadeTransition2);

        sequentialTransition= createSequentialTransition(parallelTransition1, parallelTransition2);



        fadeTransition1     = createFadeTransition(1000, result0, 0, 1);
        fadeTransition2     = createFadeTransition(1000, compareBitsBox, 0, 1);


        parallelTransition1 = createParallelTransition(fadeTransition1, fadeTransition2);
        
        fadeTransition1     = createFadeTransition(1000, atentionImage, 0, 1);
        fadeTransition2     = createFadeTransition(1000, xorExplain0, 0, 1);

        parallelTransition2 = createParallelTransition(fadeTransition1, fadeTransition2);

        parallelTransition  = createParallelTransition(sequentialTransition,
                                                        parallelTransition1,
                                                        parallelTransition2);

        animations.add(parallelTransition);


        /*FIFTH ANIMATION: creates path to routing*/
        translateTransition = createTranslateTransition(1000, portDown_downPort, -100, 0, 0, 0);
        scaleTransition     = createScaleTransition(1000, portDown_downPort, 0, 0, 1, 1);

        parallelTransition  = createParallelTransition(translateTransition, scaleTransition);

        animations.add(parallelTransition);


        /*SIXTH ANIMATION: routing and finishing*/

        // Value being routed
        translateTransition1 = createTranslateTransition(1000, portDown_m2_bin, 265, -325, 120, 0);
        translateTransition3 = createTranslateTransition(1400, portDown_m2_bin, 120, 0, 400, 0);
        sequentialTransition1= createSequentialTransition(translateTransition1,
                                                            translateTransition3);

        translateTransition1 = createTranslateTransition(1000, portDown_p2_bin, 265, -325, 120, 0);
        translateTransition3 = createTranslateTransition(1400, portDown_p2_bin, 120, 0, 400, 0);
        sequentialTransition2= createSequentialTransition(translateTransition1,
                                                            translateTransition3);

        parallelTransition1 = createParallelTransition(sequentialTransition1,
                                                       sequentialTransition2);



        // Goodbye, value :'(
        translateTransition1 = createTranslateTransition(1500, portDown_m2_bin, 400, 0, 600, 0);
        fadeTransition1      = createFadeTransition(1500, portDown_m2_bin, 1, 0);

        translateTransition2 = createTranslateTransition(1500, portDown_p2_bin, 400, 0, 600, 0);
        fadeTransition2      = createFadeTransition(1500, portDown_p2_bin, 1, 0);

        parallelTransition2  = createParallelTransition(translateTransition1,
                                                        fadeTransition1,
                                                        translateTransition2,
                                                        fadeTransition2);


        // The routing line is gone!
        translateTransition  = createTranslateTransition(1000, portDown_downPort, 0, 0, 100, 0);
        scaleTransition      = createScaleTransition(1000, portDown_downPort, 1, 1, 0, 0);
        parallelTransition3  = createParallelTransition(translateTransition, scaleTransition);

        // Comparation values are gone!
        fadeTransition1      = createFadeTransition(1000, result0, 1, 0);
        fadeTransition2      = createFadeTransition(1000, compareBitsBox, 1, 0);
        parallelTransition4  = createParallelTransition(fadeTransition1, fadeTransition2);

        // Explain 
        fadeTransition1      = createFadeTransition(1000, atentionImage, 1, 0);
        fadeTransition2      = createFadeTransition(1000, xorExplain0, 1, 0);

        parallelTransition5  = createParallelTransition(fadeTransition1, fadeTransition2);

        // Arrow of explain is gone!
        scaleTransition     = createScaleTransition(900, lineToFoward, 1, 1, 0, 1);
        translateTransition = createTranslateTransition(900, lineToFoward, 0, 0, 40, 0);

        parallelTransition6 = createParallelTransition(scaleTransition, translateTransition);

        fadeTransition1     = createFadeTransition(100, arrowLineToFoward, 1, 0);
        fadeTransition2     = createFadeTransition(100, forwardText, 1, 0);

        parallelTransition7 = createParallelTransition(fadeTransition1,  fadeTransition2);

        sequentialTransition= createSequentialTransition(parallelTransition6, parallelTransition7);


        parallelTransition  = createParallelTransition(parallelTransition2,
                                                        parallelTransition3,
                                                        parallelTransition4,
                                                        parallelTransition5,
                                                        sequentialTransition);


        sequentialTransition1= createSequentialTransition(parallelTransition1,
                                                          parallelTransition);


        
        /*FINAL ANIMATION: values inside boxSwitch go back!*/
        // boxSwitch texts animation
        translateTransition = createTranslateTransition(2000, textSwitch, 0, 130, 0, 0);
        scaleTransition = createScaleTransition(2000, textSwitch, 0.5f, 0.5f, 1f, 1f);

        // Decimal Values vanish
        fadeTransition1 = createFadeTransition(1000, portUp, 0, 1);
        fadeTransition2 = createFadeTransition(1000, portDown, 0, 1);
        parallelTransition1 = createParallelTransition(fadeTransition1, fadeTransition2);

        parallelTransition = createParallelTransition(translateTransition,
                                                        scaleTransition,
                                                        parallelTransition1);        

        sequentialTransition= createSequentialTransition(sequentialTransition1,
                                                         parallelTransition);
       

        animations.add(sequentialTransition);

        return animations;
    }


    public void initialize(java.net.URL location, java.util.ResourceBundle resources)
    {
        animations = createAnimationsForSimulation("2B");

        velocity = 1;

        button1A.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");
        button1B.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");
        button1C.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");
        button1D.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");

        button2A.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");
        button2B.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");
        button2C.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");
        button2D.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");

        button3A.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");
        button3B.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");
        button3C.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");
        button3D.setStyle("-fx-background-color: slateblue; -fx-text-fill: white;");
    }

    @FXML protected void clickButton(ActionEvent event)
    {
        if ((actualAnimation < animations.size())) 
        {

            if (actualAnimation == 0 ||
                (animations.get(actualAnimation-1).getStatus() != Animation.Status.RUNNING))
            {
                animations.get(actualAnimation).setRate(velocity);
                animations.get(actualAnimation).play();

                actualAnimation++;

                if (actualAnimation == animations.size())
                {
                    showOptionsForNextSimulation();

                    actualAnimation = 0;
                }
            }
        }
    }



    @FXML protected void clickReverseButton (ActionEvent event)
    {
        if (actualAnimation > 0 && (animations.get(actualAnimation-1).getStatus() != Animation.Status.RUNNING))
        {
            animations.get(actualAnimation-1).setRate(-1*velocity);
            animations.get(actualAnimation-1).play();
            actualAnimation--;
        }
    }

    @FXML protected void fastMode (ActionEvent event)
    {
        if (fastModeButton.isSelected())
            velocity = 2;
        else
            velocity = 1;

        if (actualAnimation>0 && animations.get(actualAnimation-1).getStatus() == Animation.Status.RUNNING)
            animations.get(actualAnimation-1).setRate(velocity);
    }

    private void showOptionsForNextSimulation()
    {
        nextButton.setVisible(false);
        prevButton.setVisible(false);

        textSelectSwitch.setVisible(true);

        FadeTransition fadeTransition = createFadeTransition(500, textSelectSwitch, 0, 1);
        TranslateTransition translateTransition = createTranslateTransition(500, textSelectSwitch, 0, -50, 0, 0);

        ParallelTransition parallelTransition = createParallelTransition(fadeTransition, translateTransition);

        parallelTransition.play();
        //textSelectSwitch.setVisible(true);

        button1A.setVisible(true);
        button1B.setVisible(true);
        button1C.setVisible(true);
        button1D.setVisible(true);

        button2A.setVisible(true);
        button2B.setVisible(true);
        button2C.setVisible(true);
        button2D.setVisible(true);

        button3A.setVisible(true);
        button3B.setVisible(true);
        button3C.setVisible(true);
        button3D.setVisible(true);
    }

    private void hideOptionsForNextSimulation()
    {
        button1A.setVisible(false);
        button1B.setVisible(false);
        button1C.setVisible(false);
        button1D.setVisible(false);

        button2A.setVisible(false);
        button2B.setVisible(false);
        button2C.setVisible(false);
        button2D.setVisible(false);

        button3A.setVisible(false);
        button3B.setVisible(false);
        button3C.setVisible(false);
        button3D.setVisible(false);


        FadeTransition fadeTransition = createFadeTransition(0, textSelectSwitch, 1, 0);
        TranslateTransition translateTransition = createTranslateTransition(0, textSelectSwitch, 0, 0, 0, -50);

        ParallelTransition parallelTransition = createParallelTransition(fadeTransition, translateTransition);

        parallelTransition.play();

        textSelectSwitch.setVisible(false);


        nextButton.setVisible(true);
        prevButton.setVisible(true);       
    }

    @FXML protected void clickButton1A (ActionEvent event)
    {
        animations = createAnimationsForSimulation("1A");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton1B (ActionEvent event)
    {
        animations = createAnimationsForSimulation("1B");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton1C (ActionEvent event)
    {
        animations = createAnimationsForSimulation("1C");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton1D (ActionEvent event)
    {
        animations = createAnimationsForSimulation("1D");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton2A (ActionEvent event)
    {
        animations = createAnimationsForSimulation("2A");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton2B (ActionEvent event)
    {
        animations = createAnimationsForSimulation("2B");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton2C (ActionEvent event)
    {
        animations = createAnimationsForSimulation("2C");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton2D (ActionEvent event)
    {
        animations = createAnimationsForSimulation("2D");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton3A (ActionEvent event)
    {
        animations = createAnimationsForSimulation("3A");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton3B (ActionEvent event)
    {
        animations = createAnimationsForSimulation("3B");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton3C (ActionEvent event)
    {
        animations = createAnimationsForSimulation("3C");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }

    @FXML protected void clickButton3D (ActionEvent event)
    {
        animations = createAnimationsForSimulation("3D");

        hideOptionsForNextSimulation();

        actualAnimation = 0;
    }




    private TranslateTransition createTranslateTransition(int milis_duration, Node node, int fromX, int fromY,
                                                        int toX, int toY)
    {
        TranslateTransition translateTransition = new TranslateTransition(Duration.millis(milis_duration), node);
        translateTransition.setFromX(fromX);
        translateTransition.setToX(toX);
        translateTransition.setFromY(fromY);
        translateTransition.setToY(toY);
        translateTransition.setCycleCount(1);
        translateTransition.setAutoReverse(false);

        return translateTransition;
    }

    private ScaleTransition createScaleTransition(int milis_duration, Node node, float fromScaleX,
                                                    float fromScaleY, float toScaleX, float toScaleY)
    {
        ScaleTransition scaleTransition =  new ScaleTransition(Duration.millis(milis_duration), node);
        scaleTransition.setFromX(fromScaleX);
        scaleTransition.setToX(toScaleX);
        scaleTransition.setFromY(fromScaleY);
        scaleTransition.setToY(toScaleY);
        scaleTransition.setCycleCount(1);
        scaleTransition.setAutoReverse(false);

        return scaleTransition;
    }

    private FadeTransition createFadeTransition(int milis_duration, Node node, float fromValue, float toValue)
    {
        FadeTransition fadeTransition = new FadeTransition(Duration.millis(milis_duration), node);
        fadeTransition.setFromValue(fromValue);
        fadeTransition.setToValue(toValue);
        fadeTransition.setCycleCount(1);
        fadeTransition.setAutoReverse(false);

        return fadeTransition;
    }

    
    private ParallelTransition createParallelTransition(ArrayList<Transition> transitions)
    {
        ParallelTransition parallelTransition = new ParallelTransition();
        
        for (Transition anim : transitions)
            parallelTransition.getChildren().add(anim);
        
        parallelTransition.setCycleCount(1);

        return parallelTransition;
    }

    private ParallelTransition createParallelTransition (Transition... transitions)
    {
        ParallelTransition parallelTransition = new ParallelTransition();
        
        //for (Transition anim : transitions)
        parallelTransition.getChildren().addAll(transitions);
        
        parallelTransition.setCycleCount(1);

        return parallelTransition;
    }

    private SequentialTransition createSequentialTransition (Transition... transitions)
    {
        SequentialTransition sequentialTransition = new SequentialTransition();
        
        sequentialTransition.getChildren().addAll(transitions);

        return sequentialTransition;
    }

    @FXML
    private void returnMenu(ActionEvent event) throws Exception {
        
        Parent root = FXMLLoader.load( getClass().getResource("/mainmenu/FXMLMainMenuEnglish.fxml") );
        
        Scene scene = new Scene (root);
        
        Stage stage = (Stage) ((Node)event.getSource()).getScene().getWindow();
        
        stage.setScene (scene);
        stage.show();
    }
}